// Note: opening of the database was moved to index.html
function code_gen(length, special) {
  var iteration = 0;
  var password = "";
  var randomNumber;
  if(special == undefined){
      var special = false;
  }
  while(iteration < length){
    randomNumber = (Math.floor((Math.random() * 100)) % 94) + 33;
    if(!special){
      if ((randomNumber >=33) && (randomNumber <=47)) { continue; }
      if ((randomNumber >=58) && (randomNumber <=64)) { continue; }
      if ((randomNumber >=91) && (randomNumber <=96)) { continue; }
      if ((randomNumber >=123) && (randomNumber <=126)) { continue; }
    }
    iteration++;
    password += String.fromCharCode(randomNumber);
  }
  return password;
}

(function (root)
{
  var factory =
  (function( Backbone ) {
  // ====== [UTILS] ======
  //function for generating "random" id of objects in DB
  function S4() {
     return (((1+Math.random())*0x10000)|0).toString(16).substring(1);
  }

  //function guid() {
  //   return (S4()+S4()+"-"+S4()+"-"+S4()+"-"+S4()+"-"+S4()+S4()+S4());
  //}
  // Generate a pseudo-GUID by concatenating random hexadecimals
  //  matching GUID version 4 and the standard variant.
  //var VERSION_VALUE = 0x4;// Bits to set
  //var VERSION_CLEAR = 0x0;// Bits to clear
  //var VARIANT_VALUE = 0x8;// Bits to set for Standard variant (10x)
  //var VARIANT_CLEAR = 0x3;// Bits to clear
  //function guid() {
    //var data3_version = S4();
    //data3_version = (parseInt( data3_version.charAt( 0 ), 16 ) & VERSION_CLEAR | VERSION_VALUE).toString( 16 )
      //+ data3_version.substr( 1, 3 );
    //var data4_variant = S4();
    //data4_variant = data4_variant.substr( 0, 2 )
      //+ (parseInt( data4_variant.charAt( 2 ), 16 ) & VARIANT_CLEAR | VARIANT_VALUE).toString( 16 )
      //+ data4_variant.substr( 3, 1 );
    //return( S4() + S4() + '-' + S4() + '-' + data3_version + '-' + data4_variant + '-' + S4() + S4() + S4());
  //}
  function guid() {
      return code_gen(16)
  }

  function showError(err) {
    // quota error
    if (err.code === 4 && /(android)/i.test(navigator.userAgent) && !WebSQLStore.quota_err) {
      WebSQLStore.quota_err = true
      alert('Due to an Android bug, you need at least 1 GB of free space in the internal storage of your device to run Nozbe. We are very sorry for the inconvenience. If you need further assistance you can email us at questions@nozbe.com. We will be happy to help.')
      setTimeout(function() {
        WebSQLStore.quota_err = false
      }, 3600) // max 1 alert per hour
    }
  }

  function dbTransError(err) {
    var trans_error = 'WebSQLStore trans error: ' + err.code + ' ' + err.message
    console.error(trans_error)
    Rollbar.error(trans_error)
    // Wystąpił błąd podczas wykonywania transakcji.
    // Nie powinno się tak zdarzyć...
    // Może problem z "database has been closed"?
    // https://rollbar.com/tkapelak/1Nozbe/items/27594/
    if (err.code === 0 && err.message === 'database has been closed') {
      Native.crashIfInBackgroundOrReload()
    }
    showError(err)
  }

  // ====== [ WebSQLStore ] ======

  var WebSQLStore = function (db, tableName, columns, initSuccessCallback, initErrorCallback) {
    // make columns optional for backwards compatibility w/ original API
    if (typeof columns == 'function') {
      initErrorCallback = initSuccessCallback;
      initSuccessCallback = columns;
      columns = null;
    }

    this.tableName = tableName;
    this.columns = columns || [];
    var success = function (tx,res) {
      if(initSuccessCallback) initSuccessCallback();
    };
    var error = function (tx,error) {
      console.error("Error while create table",error);
      if (initErrorCallback) initErrorCallback();
    };
    //db.transaction (function(tx) {
    //  tx.executeSql("CREATE TABLE IF NOT EXISTS `" + tableName + "` (`id` unique, `value`);",[],success, error);
    //});
    var colDefns = ["`id` unique", "`value`"];
    colDefns = colDefns.concat(this.columns.map(createColDefn));
    this._executeSql("CREATE TABLE IF NOT EXISTS `" + tableName + "` (" + colDefns.join(", ") + ");",null,success, error, {});
  };
  WebSQLStore.debug = false;
  WebSQLStore.insertOrReplace = true;
  WebSQLStore.pendingQueries = [];
  WebSQLStore.retry = 0;
  _.extend(WebSQLStore.prototype,{

    create: function (model,success,error,options) {
      //when you want use your id as identifier, use apiid attribute
      if(!model.attributes[model.idAttribute]) {
        // Reference model.attributes.apiid for backward compatibility.
        var obj = {};

        if(model.attributes.apiid){
          obj[model.idAttribute] = model.attributes.apiid;
          delete model.attributes.apiid;
        }else{
          obj[model.idAttribute] = guid();
        }
        model.set(obj);
      }

      var colNames = ["`id`", "`value`"];
      var placeholders = ['?', '?'];
      var params = [model.attributes[model.idAttribute], JSON.stringify(model.toJSON())];
      this.columns.forEach(function(col) {
        colNames.push("`" + col.name + "`");
        placeholders.push(['?']);
        params.push(model.attributes[col.name]);
      });
      var orReplace = WebSQLStore.insertOrReplace ? ' OR REPLACE' : '';
      this._executeSql("INSERT" + orReplace + " INTO `" + this.tableName + "`(" + colNames.join(",") + ")VALUES(" + placeholders.join(",") + ");", params, success, error, options);
    },

    destroy: function (model, success, error, options) {
      //console.log("sql destroy");
      var id = (model.attributes[model.idAttribute] || model.attributes.id);
      this._executeSql("DELETE FROM `"+this.tableName+"` WHERE(`id`=?);",[model.attributes[model.idAttribute]],success, error, options);
    },

    destroyAll: function (success, error, options) {
      //console.log("sql destroy all");
      this._executeSql("DELETE FROM `"+this.tableName+"`",[],success, error, options);
    },

    find: function (model, success, error, options) {
      //console.log("sql find");
      var id = (model.attributes[model.idAttribute] || model.attributes.id);
      this._executeSql("SELECT `id`, `value` FROM `"+this.tableName+"` WHERE(`id`=?);",[model.attributes[model.idAttribute]], success, error, options);
    },

    findAll: function (model, success, error, options) {
      //console.log("sql findAll");
      var params = [];
      var sql = "SELECT `id`, `value` FROM `"+this.tableName+"`";
      if (options.filters) {
        if (typeof options.filters == 'string') {
          sql += ' WHERE ' + options.filters;
        }
        else if (typeof options.filters == 'object') {
          sql += ' WHERE ' + Object.keys(options.filters).map(function(col) {
            params.push(options.filters[col]);
            return '`' + col + '` = ?';
          }).join(' AND ');
        }
        else {
          throw new Error('Unsupported filters type: ' + typeof options.filters);
        }
      }
      this._executeSql(sql, params, success, error, options);
    },

    update: function (model, success, error, options) {
      if (WebSQLStore.insertOrReplace)
        return this.create(model, success, error, options);

      //console.log("sql update")
      var id = (model.attributes[model.idAttribute] || model.attributes.id);

      var setStmts = ["`value`=?"];
      var params = [JSON.stringify(model.toJSON())];
      this.columns.forEach(function(col) {
        setStmts.push("`" + col.name + "`=?");
        params.push(model.attributes[col.name]);
      });
      params.push(model.attributes[model.idAttribute]);
      this._executeSql("UPDATE `"+this.tableName+"` SET " + setStmts.join(", ") + " WHERE(`id`=?);", params, function(tx, result) {
        if (result.rowsAffected == 1)
          success(tx, result);
        else
          error(tx, new Error('UPDATE affected ' + result.rowsAffected + ' rows'));
      }, error, options);
    },

    _save: function (model, success, error) {
      //console.log("sql _save");
      var id = (model.attributes[model.idAttribute] || model.attributes.id);
      db.transaction(function(tx) {
        tx.executeSql("");
      });
    },

    _executeSql: function (SQL, params, successCallback, errorCallback, options) {
      options = options || {}

      var that = this

      // Execute pending queries
      function _flush() {
        var queries = WebSQLStore.pendingQueries;
        WebSQLStore.pendingQueries = [];
        _execute.call(that, queries);
      }

      function _execute(SQL) {

        var trans_exec = function(SQL_tmp, success, error) {

          try {
            db.transaction(function(tx) {
              var SQL_tmp_length = SQL_tmp.length;
              for (var j = 0; j < SQL_tmp_length; j++) {

                (function(){

                  var successCallback = SQL_tmp[j][2];
                  var errorCallback = SQL_tmp[j][3];

                  tx.executeSql(
                    SQL_tmp[j][0], SQL_tmp[j][1]
                    ,function(tx,result) {
                      if (successCallback) successCallback(tx,result);
                    }
                    ,function(tx, error) {
                      if (errorCallback) return errorCallback(tx, error);
                    }
                  );

                })();
              }

            }
            ,function(err) {
              if (error) error(err)
            }
            ,function() {
              console.log('transaction for '+SQL_tmp.length+' items finished')
              if (success) success()
            });

          } catch (err) {
            // Wyłapanie błędów typu InvalidStateError (DOM Exception 11)
            // https://rollbar.com/tkapelak/1Nozbe/items/8390/
            //
            // Bez tego sync trwałby aż do osiągniecia
            // Sync.Queue.autoSyncTimeout
            if (error) error(err)
          }
        }

        if (options.transaction) {
          options.transaction.executeSql(SQL, params, successCallback, errorCallback);
        }
        else {
          if (SQL instanceof Array) {
            var length = SQL.length;
            // Math.ceil(0/100) === 0!
            var num = Math.ceil(length/100) || 1;

            var trans_exec_loop = function(i) {
              // Dzielimy na tranzakcje zawieracjące nie więcej niż 100 zapytań
              var SQL_tmp = SQL.slice(100*i, 100*i+100)
              trans_exec(SQL_tmp, function() {
                WebSQLStore.retry = 0
                i++;

                if (i == num) { // Ostatni kawałek
                  // Warunek jest spełniony w sytuacji, gdy w
                  // czasie wykonywania się transakcji na
                  // bazie danych, doszły jakieś nowe
                  // zapytania do wykonania. Gdyby nie było
                  // tego warunku, zapytania byłyby
                  // skolejkowane i wisiałyby tak długo, aż
                  // przyszłyby jakieś inne zapytania, które
                  // wyzwoliłyby setTimeout.
                  if (WebSQLStore.pendingQueries.length > 0) {
                    // Omijamy setTimeout, bo to wywołanie
                    // jest po to, żeby wykonać zapytania,
                    // które doszły w miedyczasie od
                    // setTimeout do wykonania ostatniego
                    // zapytania i siedzą już w
                    // pendingQueries.
                    _flush()
                  }
                  else { // Nie ma nic do zrobienia
                    WebSQLStore.flush = undefined
                  }
                } else trans_exec_loop(i)
              }, function(err) {
                WebSQLStore.retry++

                if (WebSQLStore.retry > 3) {
                  WebSQLStore.retry = 0
                  // Transakcja uporczywie nie chce się zakończyć
                  // sukcesem, więc ją pomijamy
                  WebSQLStore.pendingQueries = SQL.slice(100*(i+1))
                    .concat(WebSQLStore.pendingQueries)
                  if (WebSQLStore.pendingQueries.length > 0) {
                    _flush()
                  }
                  else {
                    WebSQLStore.flush = undefined
                  }
                }
                else {
                  dbTransError(err)
                  WebSQLStore.pendingQueries = SQL.slice(100*i)
                    .concat(WebSQLStore.pendingQueries)
                  _flush()
                }
              })
            }

            trans_exec_loop(0)

          }
          else {
            db.transaction(function(tx) {
              tx.executeSql(
                SQL, params
                ,function(tx,result) {
                  if(successCallback) successCallback(tx,result);
                }
                ,function(tx,result) {
                  if(errorCallback) return errorCallback(tx,result);
                }
              );
            }, dbTransError);
          }
        }
      }

      if (['INS', 'UPD', 'DEL'].indexOf(SQL.substr(0, 3)) === 0) {
        WebSQLStore.pendingQueries.push([SQL, params, successCallback, errorCallback]);

        if (!WebSQLStore.flush) {
          WebSQLStore.flush = setTimeout(function() {
            _flush()
          }, 100);
        }

      }
      else {
        _execute.call(this, SQL);
      }

    }
  });

  // ====== [ Backbone.sync WebSQL implementation ] ======

  Backbone.sync = function (method, model, options) {
    var store = model.store ||
      (model.collection && model.collection.store),
      success,
      error;

    if (store == null || _.isUndefined(store)) {
      console.warn("[BACKBONE-WEBSQL] model without store object -> ", model);
      return;
    }
    var isSingleResult = false;

    success = function (tx, res) {
      var len = res.rows.length,result, i;
      if (len > 0) {
        result = [];

        for (i=0;i<len;i++) {
          result.push(JSON.parse(res.rows.item(i).value));
        }
        if(isSingleResult && result.length!==0){
          result = result[0];
        }
      }

      options.success(result);
    };
    error = function (tx,error) {
      console.error("sql error");
      console.error(error);
      console.error(tx);
      Rollbar.error('WebSQL error: ' + error.message)
      showError(error)
      options.error(error);
    };

        //if(One.data.user) One.Sync.trigger('start')

    switch(method) {
      case "read":
        if(model.attributes && model.attributes[model.idAttribute]){
          isSingleResult = true;
          store.find(model,success,error,options)
        }else{
          store.findAll(model, success, error, options)
        }

        break;
      case "create":  store.create(model,success,error,options);
        break;
      case "update":  store.update(model,success,error,options);
        break;
      case "delete":  store.destroy(model,success,error,options);
        break;
      default:
        console.error(method);
    }
  };

  var typeMap = {
    "number": "INTEGER",
    "string": "TEXT",
    "boolean": "BOOLEAN",
    "array": "LIST",
    "datetime": "TEXT",
    "date": "TEXT",
    "object": "TEXT"
  };
  function createColDefn(col) {
    if (col.type && !(col.type in typeMap))
      throw new Error("Unsupported type: " + col.type);

    var defn = "`" + col.name + "`";
    if (col.type) {
      if (col.scale)
        defn += " REAL";
      else
        defn += " " + typeMap[col.type];
    }
    return defn;
  }

  return WebSQLStore
  })

  if (typeof exports !== 'undefined')
  {
      factory(require('backbone'));
  }
  else if (typeof define === 'function' && define.amd)
  {
    define(['backbone'], factory);
  }
  else
  {
    root.WebSQLStore = factory(root.Backbone)
  }


  window.nozLocalStorage = localStorage
})(this)
